import { defineComponent as q, computed as z, ref as O, watch as _, shallowRef as D, onMounted as G, createVNode as n, resolveComponent as w, mergeProps as p, toRef as K, unref as S, Fragment as H, nextTick as x, isVNode as J } from "vue";
import { formProps as Q, formEmits as W } from "./props.js";
import { dialogProps as X, dialogEmits as Y, ElFormItem as F, ElCol as L } from "element-plus";
import { pickObjByKeys as v, firstUppercase as Z, deepClone as ee, omitObjByKeys as oe } from "@tomiaa/utils";
import { KCustomElement as m } from "../../customElement/index.js";
import { Toolbar as le, Editor as te } from "@wangeditor/editor-for-vue";
import "@wangeditor/editor/dist/css/style.css";
function ne(l) {
  return typeof l == "function" || Object.prototype.toString.call(l) === "[object Object]" && !J(l);
}
const pe = q({
  name: "KForm",
  props: Q,
  emits: W,
  setup(l, {
    attrs: g,
    slots: u,
    emit: i,
    expose: U
  }) {
    const b = l.modelValue !== void 0, j = ["", !1].includes(g.inline), B = z(() => v(l, Object.keys(X))), k = {};
    for (const e in Y)
      k["on" + Z(e)] = (...o) => i(e, ...o);
    const f = O(), I = () => n(w("el-dialog"), p({
      ref: f
    }, k, {
      onClosed: () => {
        var e;
        !l.destroyOnClose || (y(), (e = s.value) == null || e.resetFields());
      }
    }, B.value), {
      footer: l.showActions ? R : void 0,
      ...u,
      default: A
    }), R = () => {
      var o, r, a, V;
      let e = [{
        el: "el-button",
        type: "primary",
        "v-if": l.actionsConfig.showSubmit,
        onClick() {
          var P, T;
          const c = {
            formRef: s,
            dialogRef: f,
            formModel: t,
            validate: (P = s.value) == null ? void 0 : P.validate,
            rawFormModel: h()
          };
          if (l.autoValidateOnSubmit) {
            (T = s.value) == null || T.validate(($) => {
              i($ ? "submit" : "submitCheckFail", c);
            });
            return;
          }
          i("submit", c);
        },
        children: (o = l.actionsConfig.submitText) != null ? o : "\u63D0\u4EA4"
      }, {
        el: "el-button",
        "v-if": l.actionsConfig.showReset,
        onClick() {
          var c;
          s.value.resetFields(), i("reset", {
            formRef: s,
            dialogRef: f,
            formModel: t,
            validate: (c = s.value) == null ? void 0 : c.validate,
            rawFormModel: h()
          });
        },
        children: (r = l.actionsConfig.resetText) != null ? r : "\u91CD\u7F6E"
      }, {
        el: "el-button",
        "v-if": l.actionsConfig.showCancel,
        onClick() {
          i("update:modelValue", !1), i("cancel");
        },
        children: (a = l.actionsConfig.cancelText) != null ? a : "\u53D6\u6D88"
      }];
      return (V = l.actionsConfig) != null && V.custom && (e = l.actionsConfig.custom(e)), b ? n(m, {
        list: e
      }, null) : j ? n(F, null, {
        default: () => [n(m, {
          list: e
        }, null)]
      }) : n(L, l.actionsConfig, {
        default: () => [n(F, null, {
          default: () => [n(m, {
            list: e
          }, null)]
        })]
      });
    }, s = O(), t = O(l.model);
    _(t, (e) => {
      i("update:model", e);
    });
    const y = () => {
      t.value = {}, l.options.forEach((e) => {
        if (e.prop && typeof e.prop == "string") {
          const o = e.el === "el-upload" ? "fileList" : "modelValue";
          t.value[e.prop] = K(e, o);
        }
      });
    };
    y();
    const h = () => {
      const e = {};
      for (const o in t.value)
        e[o] = S(t.value[o]);
      return e;
    }, A = () => n(w("el-form"), p(g, {
      ref: s,
      model: t.value
    }), {
      default: () => [n(w("el-row"), g, {
        default: () => [E(l.options), l.showActions && !b && R()]
      })]
    }), E = (e) => e.map((o) => {
      if (o = S(o), Array.isArray(o))
        return E(o);
      o.el === "el-upload" && (o.fileList = t.value[o.prop], o["onUpdate:fileList"] = (a) => {
        Object.prototype.hasOwnProperty.call(t.value, o.prop) && (t.value[o.prop] = a);
      });
      let r = {
        ...v(o, Object.keys(L.props)),
        class: o.class ? `${o.class}__el-col` : "",
        el: "el-col",
        children: {
          ...v(o, Object.keys(F.props)),
          class: o.class ? `${o.class}__el-form-item` : "",
          el: "el-form-item",
          children: o
        }
      };
      return j && (r = r.children), o.el === "editor" && (r.children.children = N(o)), n(m, {
        model: t.value,
        list: r
      }, ne(u) ? u : {
        default: () => [u]
      });
    }), d = D({}), N = (e) => (e.prop && !d.value[e.prop] && (d.value[e.prop] = D()), n(H, null, [n(le, p({
      style: "border-bottom: 1px solid #ccc",
      mode: "default",
      editor: e.prop && d.value[e.prop].value
    }, e.editorAttrs), null), n(te, p({
      style: "height: 300px; width: 100%; overflow-y: hidden",
      mode: "default",
      modelValue: t.value[e.prop],
      "onUpdate:model-value": (o) => {
        Object.prototype.hasOwnProperty.call(t.value, e.prop) && (t.value[e.prop] = o);
      },
      onOnCreated: (o) => {
        !e.prop || (d.value[e.prop].value = o, K(e, "ref").value = o);
      }
    }, e.toolbarAttrs), null)])), C = {
      initFormModel: y,
      getRawFormModel: h,
      setFormModel: async (e, {
        includes: o = [...l.options.map((a) => a.prop).filter((a) => a), "id"],
        exclude: r = []
      } = {}) => {
        e = ee(e);
        let a = o != null && o.length ? v(e, o) : e;
        r != null && r.length && (a = oe(a, r)), await x(), Object.assign(t.value, a);
      },
      getFormRef: () => s,
      getDialogRef: () => f,
      formModel: t
    }, M = async () => {
      await x(), Object.assign(C, s.value), Object.assign(C, f.value);
    };
    return G(M), _(() => l.modelValue, M), U(C), () => n("div", null, [b ? I() : A()]);
  }
});
export {
  pe as default
};
